const radius = require('radius');
const dgram = require('dgram');
let redis = require('./redis')
redis.init()
const secret = 'secret'; // Replace with your shared secret
const port = 1812; // Default RADIUS authentication port
const portAcc = 1813; // Default RADIUS authentication port
let reject = 'Access-Reject'
let accept = 'Access-Accept'
let maxConnection = 2

const serverAuth = dgram.createSocket('udp4');
const serverAccounting = dgram.createSocket('udp4');

serverAuth.on('message', (msg, rinfo) => {
    const packet = radius.decode({packet: msg, secret});

    if (packet.code !== 'Access-Request') {
        console.error('Invalid packet type: ' + packet.code);
        return;
    }

    const username = packet.attributes['User-Name'];
    if (username === 'root')
        return;
    const password = packet.attributes['User-Password'];
    let ip = packet.attributes['Calling-Station-Id']
    let user = {username, password, ip}


    doAuth(packet, user, rinfo)
});

serverAuth.on('listening', () => {
    const address = serverAuth.address();
    console.log('RADIUS server  Auth listening on port', address.port);
});

serverAccounting.on('message', (msg, rinfo) => {
    const packet = radius.decode({packet: msg, secret});
    console.log(packet)
    if (packet.code !== 'Access-Request') {
        console.error('Invalid packet type: ' + packet.code);
        return;
    }


});

serverAccounting.on('listening', () => {
    const address = serverAccounting.address();
    console.log('RADIUS server Accounting listening on port', address.port);
});

serverAccounting.bind(portAcc);

serverAuth.bind(port);



async function doAuth(packet, user, rinfo) {
    let existsUser = authenticateUser(user.username)
    if (!existsUser) {
        console.log('uuid with ' + user.username + ' with ip:' + user.ip + ' not exist')
        sendResponsePacket(packet, rinfo, reject)
        return
    }
    let keys = await redis.getAllKeysByUUID(user.username)

    for (let i = 0; i < keys.length; i++) {
        if (user.username + '_' + user.ip === keys[i]) {
            console.log('uuid with ' + user.username + ' with ip:' + user.ip + ' granted')
            sendResponsePacket(packet, rinfo, accept)
            redis.addIp(user.username, user.ip)
            return
        }
    }
    if (keys.length >= maxConnection) {
        console.log('uuid with ' + user.username + ' with ip:' + user.ip + ' reach limits')
        sendResponsePacket(packet, rinfo, reject)
        return
    }
    console.log('uuid with ' + user.username + ' with ip:' + user.ip + ' granted')
    sendResponsePacket(packet, rinfo, accept)
    redis.addIp(user.username, user.ip)

}

function authenticateUser(username) {
    //  console.log(username,password)
    // Replace this function with your actual authentication logic
    return username === 'ali';
}

function sendResponsePacket(packet, rinfo, code) {
    let response;
    response = radius.encode_response({
        packet,
        code: code,
        secret,
    });


    serverAuth.send(response, 0, response.length, rinfo.port, rinfo.address);
}
